import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import {TodoListComponent} from "./todo-list/todo-list.component";
import {HomeComponent} from "./home/home.component";
import {PageNotFoundComponent} from "./page-not-found/page-not-found.component";
import {NewTodoComponent} from "./new-todo/new-todo.component";
import {EditTodoComponent} from "./edit-todo/edit-todo.component";
import {GuestGuardService} from "./guest-guard.service";

const routes: Routes = [
  {
    path: '',
    redirectTo: 'todos',
    pathMatch: 'full'
  },
  {path: 'home', component: HomeComponent},
  {path: 'todos', component: TodoListComponent},
  {path: 'todos/new', component: NewTodoComponent},
  {path: 'todos/:id/edit', component: EditTodoComponent},
  {path: '**', component: PageNotFoundComponent}
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule],
  providers: []
})
export class AppRoutingModule { }
