import {Component, OnInit, OnDestroy} from "@angular/core";
import {Router, ActivatedRoute} from "@angular/router";
import {TodoService} from "../todo.service";
import {Subscription} from "rxjs";

@Component({
  selector: 'app-edit-todo',
  templateUrl: './edit-todo.component.html',
  styleUrls: ['./edit-todo.component.css']
})
export class EditTodoComponent implements OnInit, OnDestroy {

  todo = {id: '',title: '', content: ''};
  subscription: Subscription;

  constructor(
      private router: Router,
      private route: ActivatedRoute,
      private todoService: TodoService
  ) {}

  gotoTodos() {
    this.router.navigate(['/todos']);
  }

  ngOnInit() {
    let id = this.route.snapshot.params['id'];
    //console.log(id);
    this.todoService.getTodo(id)
        .subscribe(
            todo => {
              if (todo) {
                this.todo = todo;
                console.log(todo);
              } else {
                this.router.navigate(['/404']);
              }
            });
  }

  ngOnDestroy() {
    if (this.subscription) {
      this.subscription.unsubscribe();
    }
  }

  updateTodo(todo) {
    console.log(todo.id);
    this.todoService.updateTodo(todo)
        .subscribe(() => this.router.navigate(['/todos']));
      
  }

}
