import {Component, OnInit, OnDestroy} from '@angular/core';
import {Router} from "@angular/router";
import {TodoService} from "../todo.service";
import {Subscription} from "rxjs";

@Component({
  selector: 'app-new-todo',
  templateUrl: './new-todo.component.html',
  styleUrls: ['./new-todo.component.css']
})
export class NewTodoComponent implements OnInit, OnDestroy {

  todo = {title: '', content: ''};
  subscription: Subscription;

  constructor(
      private router: Router,
      private todoService: TodoService
  ) { }

  gotoTodos() {
    this.router.navigate(['/todos']);
  }

  newTodo(todo) {
    this.todoService.addTodo(todo)
        .subscribe(id => this.router.navigate(['/todos']));
  }

  ngOnInit() {
  }

  ngOnDestroy() {
    if (this.subscription) {
      this.subscription.unsubscribe()
    };
  }

}
