import { Injectable } from '@angular/core';
import { Http, Headers, RequestOptions } from '@angular/http';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/delay';
import 'rxjs/add/operator/do';

//import { environment } from '../environments/environment';

@Injectable()
export class TodoService {
    //backendBaseUrl: string = environment.url + 'todos.php';
    backendBaseUrl: string = 'http://localhost:3000/api';
    headers                = new Headers({'Content-Type': 'application/json'});
    options                = new RequestOptions({headers: this.headers/*, withCredentials: true*/});
    
    constructor(private http: Http) {}

    getTodos(delay = 0): Observable<any> {
        return this.http
            .get(this.backendBaseUrl+'/todos')
            .delay(delay)
            .map(res => res.json().data);
    }
    
    getTodo(id): Observable<any> {
        let url = this.backendBaseUrl + '/todos/' + id;
        return this.http.get(url)
            .map(res => res.json().data);
    }
    
    addTodo(todo): Observable<any> {
        let url = this.backendBaseUrl + '/todos';
        let body = JSON.stringify(todo);
        console.log(body);
        return this.http.post(url, body, this.options)
            .map(res => res.json().data);
    }
    
    updateTodo(todo): Observable<any> {
        let url = this.backendBaseUrl + '/todos/' + todo._id;
        console.log(url);
        let body = JSON.stringify(todo);
        return this.http.put(url, body, this.options)
            .map(res => res.json());
    }
    
    deleteTodo(id): Observable<any> {
        let url = this.backendBaseUrl + '/todos/' + id;
        return this.http.delete(url, this.options)
            .map(res => res.json());
    }
    
    toggleDone(id): Observable<any> {
        let url = this.backendBaseUrl + '/todos/toggleDone/' + id;
        return this.http.put(url, '', this.options)
                   .map(res => res.json())
                   .do(data => console.log(data));
    }
    
    clearDone(): Observable<any> {
        let url = this.backendBaseUrl + '?op=clearDone';
        return this.http.delete(url, this.options)
                   .map(res => res.json());
    }
}