import {Component, Input, Output, EventEmitter} from '@angular/core';
import {Router} from "@angular/router";

@Component({
  selector: 'app-todo',
  templateUrl: './todo.component.html',
  styleUrls: ['./todo.component.css']
})
export class TodoComponent {

  @Input() todo;
  @Output() delete = new EventEmitter();
  @Output() toggle = new EventEmitter();

  constructor(private router: Router) {}

  toggleDone(id) {
    this.toggle.emit(id);
  }

  get classObj() {
    return {'panel-primary': !this.todo.done, 'panel-default': this.todo.done};
  }

  editTodo(id) {
    this.router.navigate([`/todos/${id}/edit`]);
  }

  deleteTodo(id) {
    this.delete.emit(id);
  }
}
