/*!
 * idtoken-verifier.min.js v1.0.2
 * 
 * Author: Auth0
 * Date: 6/15/2017, 7:46:49 PM
 * License: MIT
 * 
 */
!function(t,e){"object"==typeof exports&&"object"==typeof module?module.exports=e():"function"==typeof define&&define.amd?define("idtoken-verifier",[],e):"object"==typeof exports?exports["idtoken-verifier"]=e():t["idtoken-verifier"]=e()}(this,function(){return function(t){function e(i){if(r[i])return r[i].exports;var o=r[i]={exports:{},id:i,loaded:!1};return t[i].call(o.exports,o,o.exports,e),o.loaded=!0,o.exports}var r={};return e.m=t,e.c=r,e.p="",e(0)}([function(t,e,r){function i(t){var e=t||{};if(this.jwksCache=e.jwksCache||new a,this.expectedAlg=e.expectedAlg||"RS256",this.issuer=e.issuer,this.audience=e.audience,this.leeway=e.leeway||0,this.__disableExpirationCheck=e.__disableExpirationCheck||!1,this.leeway<0||this.leeway>60)throw new h.ConfigurationError("The leeway should be positive and lower than a minute.");if(u.indexOf(this.expectedAlg)===-1)throw new h.ConfigurationError("Algorithm "+this.expectedAlg+" is not supported. (Expected algs: ["+u.join(",")+"])")}var o=r(18),n=r(2),s=r(17),h=r(16),a=r(15),u=["RS256"];i.prototype.verify=function(t,e,r){var i=this.decode(t);if(i instanceof Error)return r(i,!1);var o=i.encoded.header+"."+i.encoded.payload,s=n.decodeToHEX(i.encoded.signature),a=i.header.alg,p=i.header.kid,f=i.payload.aud,c=i.payload.iss,l=i.payload.exp,d=i.payload.iat,y=i.payload.nonce||null;if(this.issuer!==c)return r(new h.TokenValidationError("Issuer "+c+" is not valid."),!1);if(this.audience!==f)return r(new h.TokenValidationError("Audience "+f+" is not valid."),!1);if(this.expectedAlg!==a)return r(new h.TokenValidationError("Algorithm "+a+" is not supported. (Expected algs: ["+u.join(",")+"])"),!1);if(y!==e)return r(new h.TokenValidationError("Nonce does not match."),!1);var m=this.verifyExpAndIat(l,d);return m?r(m,!1):this.getRsaVerifier(c,p,function(t,e){return t?r(t):e.verify(o,s)?r(null,i.payload):r(new h.TokenValidationError("Invalid signature."))})},i.prototype.verifyExpAndIat=function(t,e){var r=new Date,i=new Date(0),o=new Date(0);return this.__disableExpirationCheck?null:(i.setUTCSeconds(t+this.leeway),r>i?new h.TokenValidationError("Expired token."):(o.setUTCSeconds(e-this.leeway),r<o?new h.TokenValidationError("The token was issued in the future. Please check your computed clock."):null))},i.prototype.getRsaVerifier=function(t,e,r){var i=this,n=t+e;if(this.jwksCache.has(n)){var h=this.jwksCache.get(n);r(null,new o(h.modulus,h.exp))}else s.getJWKS({iss:t,kid:e},function(t,e){t&&r(t),i.jwksCache.set(n,e),r(null,new o(e.modulus,e.exp))})},i.prototype.decode=function(t){var e,r,i=t.split(".");if(3!==i.length)return new h.TokenValidationError("Cannot decode a malformed JWT");try{e=JSON.parse(n.decodeToString(i[0])),r=JSON.parse(n.decodeToString(i[1]))}catch(t){return new h.TokenValidationError("Token header or payload is not valid JSON")}return{header:e,payload:r,encoded:{header:i[0],payload:i[1],signature:i[2]}}},t.exports=i},function(t,e){function r(t){return null!==t&&"object"==typeof t}t.exports=r},function(t,e,r){function i(t){var e=t.length%4,r=4-e;return 0===e?t:t+new Array(1+r).join("=")}function o(t){for(var e="",r=0;r<t.length;r++)e+=String.fromCharCode(t[r]);return e}function n(t){for(var e=new Array(t.length),r=0;r<t.length;r++)e[r]=t.charCodeAt(r);return e}function s(t){for(var e="",r=0;r<t.length;r++){var i=t[r].toString(16);e+=2===i.length?i:"0"+i}return e}function h(t){return btoa(encodeURIComponent(t).replace(/%([0-9A-F]{2})/g,function(t,e){return String.fromCharCode("0x"+e)})).replace(/\+/g,"-").replace(/\//g,"_")}function a(t){return t=i(t).replace(/\-/g,"+").replace(/_/g,"/"),decodeURIComponent(atob(t).split("").map(function(t){return"%"+("00"+t.charCodeAt(0).toString(16)).slice(-2)}).join(""))}function u(t){return s(p.toByteArray(i(t)))}var p=r(3);t.exports={encodeString:h,decodeToString:a,byteArrayToString:o,stringToByteArray:n,padding:i,byteArrayToHex:s,decodeToHEX:u}},function(t,e){"use strict";function r(t){var e=t.length;if(e%4>0)throw new Error("Invalid string. Length must be a multiple of 4");return"="===t[e-2]?2:"="===t[e-1]?1:0}function i(t){return 3*t.length/4-r(t)}function o(t){var e,i,o,n,s,h,a=t.length;s=r(t),h=new p(3*a/4-s),o=s>0?a-4:a;var f=0;for(e=0,i=0;e<o;e+=4,i+=3)n=u[t.charCodeAt(e)]<<18|u[t.charCodeAt(e+1)]<<12|u[t.charCodeAt(e+2)]<<6|u[t.charCodeAt(e+3)],h[f++]=n>>16&255,h[f++]=n>>8&255,h[f++]=255&n;return 2===s?(n=u[t.charCodeAt(e)]<<2|u[t.charCodeAt(e+1)]>>4,h[f++]=255&n):1===s&&(n=u[t.charCodeAt(e)]<<10|u[t.charCodeAt(e+1)]<<4|u[t.charCodeAt(e+2)]>>2,h[f++]=n>>8&255,h[f++]=255&n),h}function n(t){return a[t>>18&63]+a[t>>12&63]+a[t>>6&63]+a[63&t]}function s(t,e,r){for(var i,o=[],s=e;s<r;s+=3)i=(t[s]<<16)+(t[s+1]<<8)+t[s+2],o.push(n(i));return o.join("")}function h(t){for(var e,r=t.length,i=r%3,o="",n=[],h=16383,u=0,p=r-i;u<p;u+=h)n.push(s(t,u,u+h>p?p:u+h));return 1===i?(e=t[r-1],o+=a[e>>2],o+=a[e<<4&63],o+="=="):2===i&&(e=(t[r-2]<<8)+t[r-1],o+=a[e>>10],o+=a[e>>4&63],o+=a[e<<2&63],o+="="),n.push(o),n.join("")}e.byteLength=i,e.toByteArray=o,e.fromByteArray=h;for(var a=[],u=[],p="undefined"!=typeof Uint8Array?Uint8Array:Array,f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c=0,l=f.length;c<l;++c)a[c]=f[c],u[f.charCodeAt(c)]=c;u["-".charCodeAt(0)]=62,u["_".charCodeAt(0)]=63},function(t,e,r){function i(t){if(t)return o(t)}function o(t){for(var e in i.prototype)t[e]=i.prototype[e];return t}t.exports=i,i.prototype.on=i.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},i.prototype.once=function(t,e){function r(){this.off(t,r),e.apply(this,arguments)}return r.fn=e,this.on(t,r),this},i.prototype.off=i.prototype.removeListener=i.prototype.removeAllListeners=i.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r=this._callbacks["$"+t];if(!r)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var i,o=0;o<r.length;o++)if(i=r[o],i===e||i.fn===e){r.splice(o,1);break}return this},i.prototype.emit=function(t){this._callbacks=this._callbacks||{};var e=[].slice.call(arguments,1),r=this._callbacks["$"+t];if(r){r=r.slice(0);for(var i=0,o=r.length;i<o;++i)r[i].apply(this,e)}return this},i.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},i.prototype.hasListeners=function(t){return!!this.listeners(t).length}},function(t,e,r){!function(r,i){t.exports=e=i()}(this,function(){var t=t||function(t,e){var r=Object.create||function(){function t(){}return function(e){var r;return t.prototype=e,r=new t,t.prototype=null,r}}(),i={},o=i.lib={},n=o.Base=function(){return{extend:function(t){var e=r(this);return t&&e.mixIn(t),e.hasOwnProperty("init")&&this.init!==e.init||(e.init=function(){e.$super.init.apply(this,arguments)}),e.init.prototype=e,e.$super=this,e},create:function(){var t=this.extend();return t.init.apply(t,arguments),t},init:function(){},mixIn:function(t){for(var e in t)t.hasOwnProperty(e)&&(this[e]=t[e]);t.hasOwnProperty("toString")&&(this.toString=t.toString)},clone:function(){return this.init.prototype.extend(this)}}}(),s=o.WordArray=n.extend({init:function(t,r){t=this.words=t||[],r!=e?this.sigBytes=r:this.sigBytes=4*t.length},toString:function(t){return(t||a).stringify(this)},concat:function(t){var e=this.words,r=t.words,i=this.sigBytes,o=t.sigBytes;if(this.clamp(),i%4)for(var n=0;n<o;n++){var s=r[n>>>2]>>>24-n%4*8&255;e[i+n>>>2]|=s<<24-(i+n)%4*8}else for(var n=0;n<o;n+=4)e[i+n>>>2]=r[n>>>2];return this.sigBytes+=o,this},clamp:function(){var e=this.words,r=this.sigBytes;e[r>>>2]&=4294967295<<32-r%4*8,e.length=t.ceil(r/4)},clone:function(){var t=n.clone.call(this);return t.words=this.words.slice(0),t},random:function(e){for(var r,i=[],o=function(e){var e=e,r=987654321,i=4294967295;return function(){r=36969*(65535&r)+(r>>16)&i,e=18e3*(65535&e)+(e>>16)&i;var o=(r<<16)+e&i;return o/=4294967296,o+=.5,o*(t.random()>.5?1:-1)}},n=0;n<e;n+=4){var h=o(4294967296*(r||t.random()));r=987654071*h(),i.push(4294967296*h()|0)}return new s.init(i,e)}}),h=i.enc={},a=h.Hex={stringify:function(t){for(var e=t.words,r=t.sigBytes,i=[],o=0;o<r;o++){var n=e[o>>>2]>>>24-o%4*8&255;i.push((n>>>4).toString(16)),i.push((15&n).toString(16))}return i.join("")},parse:function(t){for(var e=t.length,r=[],i=0;i<e;i+=2)r[i>>>3]|=parseInt(t.substr(i,2),16)<<24-i%8*4;return new s.init(r,e/2)}},u=h.Latin1={stringify:function(t){for(var e=t.words,r=t.sigBytes,i=[],o=0;o<r;o++){var n=e[o>>>2]>>>24-o%4*8&255;i.push(String.fromCharCode(n))}return i.join("")},parse:function(t){for(var e=t.length,r=[],i=0;i<e;i++)r[i>>>2]|=(255&t.charCodeAt(i))<<24-i%4*8;return new s.init(r,e)}},p=h.Utf8={stringify:function(t){try{return decodeURIComponent(escape(u.stringify(t)))}catch(t){throw new Error("Malformed UTF-8 data")}},parse:function(t){return u.parse(unescape(encodeURIComponent(t)))}},f=o.BufferedBlockAlgorithm=n.extend({reset:function(){this._data=new s.init,this._nDataBytes=0},_append:function(t){"string"==typeof t&&(t=p.parse(t)),this._data.concat(t),this._nDataBytes+=t.sigBytes},_process:function(e){var r=this._data,i=r.words,o=r.sigBytes,n=this.blockSize,h=4*n,a=o/h;a=e?t.ceil(a):t.max((0|a)-this._minBufferSize,0);var u=a*n,p=t.min(4*u,o);if(u){for(var f=0;f<u;f+=n)this._doProcessBlock(i,f);var c=i.splice(0,u);r.sigBytes-=p}return new s.init(c,p)},clone:function(){var t=n.clone.call(this);return t._data=this._data.clone(),t},_minBufferSize:0}),c=(o.Hasher=f.extend({cfg:n.extend(),init:function(t){this.cfg=this.cfg.extend(t),this.reset()},reset:function(){f.reset.call(this),this._doReset()},update:function(t){return this._append(t),this._process(),this},finalize:function(t){t&&this._append(t);var e=this._doFinalize();return e},blockSize:16,_createHelper:function(t){return function(e,r){return new t.init(r).finalize(e)}},_createHmacHelper:function(t){return function(e,r){return new c.HMAC.init(t,r).finalize(e)}}}),i.algo={});return i}(Math);return t})},function(t,e,r){!function(i,o){t.exports=e=o(r(5))}(this,function(t){return function(e){var r=t,i=r.lib,o=i.WordArray,n=i.Hasher,s=r.algo,h=[],a=[];!function(){function t(t){for(var r=e.sqrt(t),i=2;i<=r;i++)if(!(t%i))return!1;return!0}function r(t){return 4294967296*(t-(0|t))|0}for(var i=2,o=0;o<64;)t(i)&&(o<8&&(h[o]=r(e.pow(i,.5))),a[o]=r(e.pow(i,1/3)),o++),i++}();var u=[],p=s.SHA256=n.extend({_doReset:function(){this._hash=new o.init(h.slice(0))},_doProcessBlock:function(t,e){for(var r=this._hash.words,i=r[0],o=r[1],n=r[2],s=r[3],h=r[4],p=r[5],f=r[6],c=r[7],l=0;l<64;l++){if(l<16)u[l]=0|t[e+l];else{var d=u[l-15],y=(d<<25|d>>>7)^(d<<14|d>>>18)^d>>>3,m=u[l-2],v=(m<<15|m>>>17)^(m<<13|m>>>19)^m>>>10;u[l]=y+u[l-7]+v+u[l-16]}var T=h&p^~h&f,g=i&o^i&n^o&n,w=(i<<30|i>>>2)^(i<<19|i>>>13)^(i<<10|i>>>22),b=(h<<26|h>>>6)^(h<<21|h>>>11)^(h<<7|h>>>25),_=c+b+T+a[l]+u[l],x=w+g;c=f,f=p,p=h,h=s+_|0,s=n,n=o,o=i,i=_+x|0}r[0]=r[0]+i|0,r[1]=r[1]+o|0,r[2]=r[2]+n|0,r[3]=r[3]+s|0,r[4]=r[4]+h|0,r[5]=r[5]+p|0,r[6]=r[6]+f|0,r[7]=r[7]+c|0},_doFinalize:function(){var t=this._data,r=t.words,i=8*this._nDataBytes,o=8*t.sigBytes;return r[o>>>5]|=128<<24-o%32,r[(o+64>>>9<<4)+14]=e.floor(i/4294967296),r[(o+64>>>9<<4)+15]=i,t.sigBytes=4*r.length,this._process(),this._hash},clone:function(){var t=n.clone.call(this);return t._hash=this._hash.clone(),t}});r.SHA256=n._createHelper(p),r.HmacSHA256=n._createHmacHelper(p)}(Math),t.SHA256})},function(t,e,r){(function(){function r(t,e,r){null!=t&&("number"==typeof t?this.fromNumber(t,e,r):null==e&&"string"!=typeof t?this.fromString(t,256):this.fromString(t,e))}function i(){return new r(null)}function o(t,e,r,i,o,n){for(;--n>=0;){var s=e*this[t++]+r[i]+o;o=Math.floor(s/67108864),r[i++]=67108863&s}return o}function n(t,e,r,i,o,n){for(var s=32767&e,h=e>>15;--n>=0;){var a=32767&this[t],u=this[t++]>>15,p=h*a+u*s;a=s*a+((32767&p)<<15)+r[i]+(1073741823&o),o=(a>>>30)+(p>>>15)+h*u+(o>>>30),r[i++]=1073741823&a}return o}function s(t,e,r,i,o,n){for(var s=16383&e,h=e>>14;--n>=0;){var a=16383&this[t],u=this[t++]>>14,p=h*a+u*s;a=s*a+((16383&p)<<14)+r[i]+o,o=(a>>28)+(p>>14)+h*u,r[i++]=268435455&a}return o}function h(t){return me.charAt(t)}function a(t,e){var r=ve[t.charCodeAt(e)];return null==r?-1:r}function u(t){for(var e=this.t-1;e>=0;--e)t[e]=this[e];t.t=this.t,t.s=this.s}function p(t){this.t=1,this.s=t<0?-1:0,t>0?this[0]=t:t<-1?this[0]=t+this.DV:this.t=0}function f(t){var e=i();return e.fromInt(t),e}function c(t,e){var i;if(16==e)i=4;else if(8==e)i=3;else if(256==e)i=8;else if(2==e)i=1;else if(32==e)i=5;else{if(4!=e)return void this.fromRadix(t,e);i=2}this.t=0,this.s=0;for(var o=t.length,n=!1,s=0;--o>=0;){var h=8==i?255&t[o]:a(t,o);h<0?"-"==t.charAt(o)&&(n=!0):(n=!1,0==s?this[this.t++]=h:s+i>this.DB?(this[this.t-1]|=(h&(1<<this.DB-s)-1)<<s,this[this.t++]=h>>this.DB-s):this[this.t-1]|=h<<s,s+=i,s>=this.DB&&(s-=this.DB))}8==i&&0!=(128&t[0])&&(this.s=-1,s>0&&(this[this.t-1]|=(1<<this.DB-s)-1<<s)),this.clamp(),n&&r.ZERO.subTo(this,this)}function l(){for(var t=this.s&this.DM;this.t>0&&this[this.t-1]==t;)--this.t}function d(t){if(this.s<0)return"-"+this.negate().toString(t);var e;if(16==t)e=4;else if(8==t)e=3;else if(2==t)e=1;else if(32==t)e=5;else{if(4!=t)return this.toRadix(t);e=2}var r,i=(1<<e)-1,o=!1,n="",s=this.t,a=this.DB-s*this.DB%e;if(s-- >0)for(a<this.DB&&(r=this[s]>>a)>0&&(o=!0,n=h(r));s>=0;)a<e?(r=(this[s]&(1<<a)-1)<<e-a,r|=this[--s]>>(a+=this.DB-e)):(r=this[s]>>(a-=e)&i,a<=0&&(a+=this.DB,--s)),r>0&&(o=!0),o&&(n+=h(r));return o?n:"0"}function y(){var t=i();return r.ZERO.subTo(this,t),t}function m(){return this.s<0?this.negate():this}function v(t){var e=this.s-t.s;if(0!=e)return e;var r=this.t;if(e=r-t.t,0!=e)return this.s<0?-e:e;for(;--r>=0;)if(0!=(e=this[r]-t[r]))return e;return 0}function T(t){var e,r=1;return 0!=(e=t>>>16)&&(t=e,r+=16),0!=(e=t>>8)&&(t=e,r+=8),0!=(e=t>>4)&&(t=e,r+=4),0!=(e=t>>2)&&(t=e,r+=2),0!=(e=t>>1)&&(t=e,r+=1),r}function g(){return this.t<=0?0:this.DB*(this.t-1)+T(this[this.t-1]^this.s&this.DM)}function w(t,e){var r;for(r=this.t-1;r>=0;--r)e[r+t]=this[r];for(r=t-1;r>=0;--r)e[r]=0;e.t=this.t+t,e.s=this.s}function b(t,e){for(var r=t;r<this.t;++r)e[r-t]=this[r];e.t=Math.max(this.t-t,0),e.s=this.s}function _(t,e){var r,i=t%this.DB,o=this.DB-i,n=(1<<o)-1,s=Math.floor(t/this.DB),h=this.s<<i&this.DM;for(r=this.t-1;r>=0;--r)e[r+s+1]=this[r]>>o|h,h=(this[r]&n)<<i;for(r=s-1;r>=0;--r)e[r]=0;e[s]=h,e.t=this.t+s+1,e.s=this.s,e.clamp()}function x(t,e){e.s=this.s;var r=Math.floor(t/this.DB);if(r>=this.t)return void(e.t=0);var i=t%this.DB,o=this.DB-i,n=(1<<i)-1;e[0]=this[r]>>i;for(var s=r+1;s<this.t;++s)e[s-r-1]|=(this[s]&n)<<o,e[s-r]=this[s]>>i;i>0&&(e[this.t-r-1]|=(this.s&n)<<o),e.t=this.t-r,e.clamp()}function E(t,e){for(var r=0,i=0,o=Math.min(t.t,this.t);r<o;)i+=this[r]-t[r],e[r++]=i&this.DM,i>>=this.DB;if(t.t<this.t){for(i-=t.s;r<this.t;)i+=this[r],e[r++]=i&this.DM,i>>=this.DB;i+=this.s}else{for(i+=this.s;r<t.t;)i-=t[r],e[r++]=i&this.DM,i>>=this.DB;i-=t.s}e.s=i<0?-1:0,i<-1?e[r++]=this.DV+i:i>0&&(e[r++]=i),e.t=r,e.clamp()}function S(t,e){var i=this.abs(),o=t.abs(),n=i.t;for(e.t=n+o.t;--n>=0;)e[n]=0;for(n=0;n<o.t;++n)e[n+i.t]=i.am(0,o[n],e,n,0,i.t);e.s=0,e.clamp(),this.s!=t.s&&r.ZERO.subTo(e,e)}function D(t){for(var e=this.abs(),r=t.t=2*e.t;--r>=0;)t[r]=0;for(r=0;r<e.t-1;++r){var i=e.am(r,e[r],t,2*r,0,1);(t[r+e.t]+=e.am(r+1,2*e[r],t,2*r+1,i,e.t-r-1))>=e.DV&&(t[r+e.t]-=e.DV,t[r+e.t+1]=1)}t.t>0&&(t[t.t-1]+=e.am(r,e[r],t,2*r,0,1)),t.s=0,t.clamp()}function A(t,e,o){var n=t.abs();if(!(n.t<=0)){var s=this.abs();if(s.t<n.t)return null!=e&&e.fromInt(0),void(null!=o&&this.copyTo(o));null==o&&(o=i());var h=i(),a=this.s,u=t.s,p=this.DB-T(n[n.t-1]);p>0?(n.lShiftTo(p,h),s.lShiftTo(p,o)):(n.copyTo(h),s.copyTo(o));var f=h.t,c=h[f-1];if(0!=c){var l=c*(1<<this.F1)+(f>1?h[f-2]>>this.F2:0),d=this.FV/l,y=(1<<this.F1)/l,m=1<<this.F2,v=o.t,g=v-f,w=null==e?i():e;for(h.dlShiftTo(g,w),o.compareTo(w)>=0&&(o[o.t++]=1,o.subTo(w,o)),r.ONE.dlShiftTo(f,w),w.subTo(h,h);h.t<f;)h[h.t++]=0;for(;--g>=0;){var b=o[--v]==c?this.DM:Math.floor(o[v]*d+(o[v-1]+m)*y);if((o[v]+=h.am(0,b,o,g,0,f))<b)for(h.dlShiftTo(g,w),o.subTo(w,o);o[v]<--b;)o.subTo(w,o)}null!=e&&(o.drShiftTo(f,e),a!=u&&r.ZERO.subTo(e,e)),o.t=f,o.clamp(),p>0&&o.rShiftTo(p,o),a<0&&r.ZERO.subTo(o,o)}}}function B(t){var e=i();return this.abs().divRemTo(t,null,e),this.s<0&&e.compareTo(r.ZERO)>0&&t.subTo(e,e),e}function k(t){this.m=t}function C(t){return t.s<0||t.compareTo(this.m)>=0?t.mod(this.m):t}function R(t){return t}function O(t){t.divRemTo(this.m,null,t)}function M(t,e,r){t.multiplyTo(e,r),this.reduce(r)}function j(t,e){t.squareTo(e),this.reduce(e)}function q(){if(this.t<1)return 0;var t=this[0];if(0==(1&t))return 0;var e=3&t;return e=e*(2-(15&t)*e)&15,e=e*(2-(255&t)*e)&255,e=e*(2-((65535&t)*e&65535))&65535,e=e*(2-t*e%this.DV)%this.DV,e>0?this.DV-e:-e}function H(t){this.m=t,this.mp=t.invDigit(),this.mpl=32767&this.mp,this.mph=this.mp>>15,this.um=(1<<t.DB-15)-1,this.mt2=2*t.t}function I(t){var e=i();return t.abs().dlShiftTo(this.m.t,e),e.divRemTo(this.m,null,e),t.s<0&&e.compareTo(r.ZERO)>0&&this.m.subTo(e,e),e}function L(t){var e=i();return t.copyTo(e),this.reduce(e),e}function P(t){for(;t.t<=this.mt2;)t[t.t++]=0;for(var e=0;e<this.m.t;++e){var r=32767&t[e],i=r*this.mpl+((r*this.mph+(t[e]>>15)*this.mpl&this.um)<<15)&t.DM;for(r=e+this.m.t,t[r]+=this.m.am(0,i,t,e,0,this.m.t);t[r]>=t.DV;)t[r]-=t.DV,t[++r]++}t.clamp(),t.drShiftTo(this.m.t,t),t.compareTo(this.m)>=0&&t.subTo(this.m,t)}function V(t,e){t.squareTo(e),this.reduce(e)}function N(t,e,r){t.multiplyTo(e,r),this.reduce(r)}function U(){return 0==(this.t>0?1&this[0]:this.s)}function z(t,e){if(t>4294967295||t<1)return r.ONE;var o=i(),n=i(),s=e.convert(this),h=T(t)-1;for(s.copyTo(o);--h>=0;)if(e.sqrTo(o,n),(t&1<<h)>0)e.mulTo(n,s,o);else{var a=o;o=n,n=a}return e.revert(o)}function F(t,e){var r;return r=t<256||e.isEven()?new k(e):new H(e),this.exp(t,r)}function X(){var t=i();return this.copyTo(t),t}function Z(){if(this.s<0){if(1==this.t)return this[0]-this.DV;if(0==this.t)return-1}else{if(1==this.t)return this[0];if(0==this.t)return 0}return(this[1]&(1<<32-this.DB)-1)<<this.DB|this[0]}function $(){return 0==this.t?this.s:this[0]<<24>>24}function J(){return 0==this.t?this.s:this[0]<<16>>16}function W(t){return Math.floor(Math.LN2*this.DB/Math.log(t))}function K(){return this.s<0?-1:this.t<=0||1==this.t&&this[0]<=0?0:1}function G(t){if(null==t&&(t=10),0==this.signum()||t<2||t>36)return"0";var e=this.chunkSize(t),r=Math.pow(t,e),o=f(r),n=i(),s=i(),h="";for(this.divRemTo(o,n,s);n.signum()>0;)h=(r+s.intValue()).toString(t).substr(1)+h,n.divRemTo(o,n,s);return s.intValue().toString(t)+h}function Q(t,e){this.fromInt(0),null==e&&(e=10);for(var i=this.chunkSize(e),o=Math.pow(e,i),n=!1,s=0,h=0,u=0;u<t.length;++u){var p=a(t,u);p<0?"-"==t.charAt(u)&&0==this.signum()&&(n=!0):(h=e*h+p,++s>=i&&(this.dMultiply(o),this.dAddOffset(h,0),s=0,h=0))}s>0&&(this.dMultiply(Math.pow(e,s)),this.dAddOffset(h,0)),n&&r.ZERO.subTo(this,this)}function Y(t,e,i){if("number"==typeof e)if(t<2)this.fromInt(1);else for(this.fromNumber(t,i),this.testBit(t-1)||this.bitwiseTo(r.ONE.shiftLeft(t-1),ht,this),this.isEven()&&this.dAddOffset(1,0);!this.isProbablePrime(e);)this.dAddOffset(2,0),this.bitLength()>t&&this.subTo(r.ONE.shiftLeft(t-1),this);else{var o=new Array,n=7&t;o.length=(t>>3)+1,e.nextBytes(o),n>0?o[0]&=(1<<n)-1:o[0]=0,this.fromString(o,256)}}function tt(){var t=this.t,e=new Array;e[0]=this.s;var r,i=this.DB-t*this.DB%8,o=0;if(t-- >0)for(i<this.DB&&(r=this[t]>>i)!=(this.s&this.DM)>>i&&(e[o++]=r|this.s<<this.DB-i);t>=0;)i<8?(r=(this[t]&(1<<i)-1)<<8-i,r|=this[--t]>>(i+=this.DB-8)):(r=this[t]>>(i-=8)&255,i<=0&&(i+=this.DB,--t)),0!=(128&r)&&(r|=-256),0==o&&(128&this.s)!=(128&r)&&++o,(o>0||r!=this.s)&&(e[o++]=r);return e}function et(t){return 0==this.compareTo(t)}function rt(t){return this.compareTo(t)<0?this:t}function it(t){return this.compareTo(t)>0?this:t}function ot(t,e,r){var i,o,n=Math.min(t.t,this.t);for(i=0;i<n;++i)r[i]=e(this[i],t[i]);if(t.t<this.t){for(o=t.s&this.DM,i=n;i<this.t;++i)r[i]=e(this[i],o);r.t=this.t}else{for(o=this.s&this.DM,i=n;i<t.t;++i)r[i]=e(o,t[i]);r.t=t.t}r.s=e(this.s,t.s),r.clamp()}function nt(t,e){return t&e}function st(t){var e=i();return this.bitwiseTo(t,nt,e),e}function ht(t,e){return t|e}function at(t){var e=i();return this.bitwiseTo(t,ht,e),e}function ut(t,e){return t^e}function pt(t){var e=i();return this.bitwiseTo(t,ut,e),e}function ft(t,e){return t&~e}function ct(t){var e=i();return this.bitwiseTo(t,ft,e),e}function lt(){for(var t=i(),e=0;e<this.t;++e)t[e]=this.DM&~this[e];return t.t=this.t,t.s=~this.s,t}function dt(t){var e=i();return t<0?this.rShiftTo(-t,e):this.lShiftTo(t,e),e}function yt(t){var e=i();return t<0?this.lShiftTo(-t,e):this.rShiftTo(t,e),e}function mt(t){if(0==t)return-1;var e=0;return 0==(65535&t)&&(t>>=16,e+=16),0==(255&t)&&(t>>=8,e+=8),0==(15&t)&&(t>>=4,e+=4),0==(3&t)&&(t>>=2,e+=2),0==(1&t)&&++e,e}function vt(){for(var t=0;t<this.t;++t)if(0!=this[t])return t*this.DB+mt(this[t]);return this.s<0?this.t*this.DB:-1}function Tt(t){for(var e=0;0!=t;)t&=t-1,++e;return e}function gt(){for(var t=0,e=this.s&this.DM,r=0;r<this.t;++r)t+=Tt(this[r]^e);return t}function wt(t){var e=Math.floor(t/this.DB);return e>=this.t?0!=this.s:0!=(this[e]&1<<t%this.DB)}function bt(t,e){var i=r.ONE.shiftLeft(t);return this.bitwiseTo(i,e,i),i}function _t(t){return this.changeBit(t,ht)}function xt(t){return this.changeBit(t,ft)}function Et(t){return this.changeBit(t,ut)}function St(t,e){for(var r=0,i=0,o=Math.min(t.t,this.t);r<o;)i+=this[r]+t[r],e[r++]=i&this.DM,i>>=this.DB;if(t.t<this.t){for(i+=t.s;r<this.t;)i+=this[r],e[r++]=i&this.DM,i>>=this.DB;i+=this.s}else{for(i+=this.s;r<t.t;)i+=t[r],e[r++]=i&this.DM,i>>=this.DB;i+=t.s}e.s=i<0?-1:0,i>0?e[r++]=i:i<-1&&(e[r++]=this.DV+i),e.t=r,e.clamp()}function Dt(t){var e=i();return this.addTo(t,e),e}function At(t){var e=i();return this.subTo(t,e),e}function Bt(t){var e=i();return this.multiplyTo(t,e),e}function kt(){var t=i();return this.squareTo(t),t}function Ct(t){var e=i();return this.divRemTo(t,e,null),e}function Rt(t){var e=i();return this.divRemTo(t,null,e),e}function Ot(t){var e=i(),r=i();return this.divRemTo(t,e,r),new Array(e,r)}function Mt(t){this[this.t]=this.am(0,t-1,this,0,0,this.t),++this.t,this.clamp()}function jt(t,e){if(0!=t){for(;this.t<=e;)this[this.t++]=0;for(this[e]+=t;this[e]>=this.DV;)this[e]-=this.DV,++e>=this.t&&(this[this.t++]=0),++this[e]}}function qt(){}function Ht(t){return t}function It(t,e,r){t.multiplyTo(e,r)}function Lt(t,e){t.squareTo(e)}function Pt(t){return this.exp(t,new qt)}function Vt(t,e,r){var i=Math.min(this.t+t.t,e);for(r.s=0,r.t=i;i>0;)r[--i]=0;var o;for(o=r.t-this.t;i<o;++i)r[i+this.t]=this.am(0,t[i],r,i,0,this.t);for(o=Math.min(t.t,e);i<o;++i)this.am(0,t[i],r,i,0,e-i);r.clamp()}function Nt(t,e,r){--e;var i=r.t=this.t+t.t-e;for(r.s=0;--i>=0;)r[i]=0;for(i=Math.max(e-this.t,0);i<t.t;++i)r[this.t+i-e]=this.am(e-i,t[i],r,0,0,this.t+i-e);r.clamp(),r.drShiftTo(1,r)}function Ut(t){this.r2=i(),this.q3=i(),r.ONE.dlShiftTo(2*t.t,this.r2),this.mu=this.r2.divide(t),this.m=t}function zt(t){if(t.s<0||t.t>2*this.m.t)return t.mod(this.m);if(t.compareTo(this.m)<0)return t;var e=i();return t.copyTo(e),this.reduce(e),e}function Ft(t){return t}function Xt(t){for(t.drShiftTo(this.m.t-1,this.r2),t.t>this.m.t+1&&(t.t=this.m.t+1,t.clamp()),this.mu.multiplyUpperTo(this.r2,this.m.t+1,this.q3),this.m.multiplyLowerTo(this.q3,this.m.t+1,this.r2);t.compareTo(this.r2)<0;)t.dAddOffset(1,this.m.t+1);for(t.subTo(this.r2,t);t.compareTo(this.m)>=0;)t.subTo(this.m,t)}function Zt(t,e){t.squareTo(e),this.reduce(e)}function $t(t,e,r){t.multiplyTo(e,r),this.reduce(r)}function Jt(t,e){var r,o,n=t.bitLength(),s=f(1);if(n<=0)return s;r=n<18?1:n<48?3:n<144?4:n<768?5:6,o=n<8?new k(e):e.isEven()?new Ut(e):new H(e);var h=new Array,a=3,u=r-1,p=(1<<r)-1;if(h[1]=o.convert(this),r>1){var c=i();for(o.sqrTo(h[1],c);a<=p;)h[a]=i(),o.mulTo(c,h[a-2],h[a]),a+=2}var l,d,y=t.t-1,m=!0,v=i();for(n=T(t[y])-1;y>=0;){for(n>=u?l=t[y]>>n-u&p:(l=(t[y]&(1<<n+1)-1)<<u-n,y>0&&(l|=t[y-1]>>this.DB+n-u)),a=r;0==(1&l);)l>>=1,--a;if((n-=a)<0&&(n+=this.DB,--y),m)h[l].copyTo(s),m=!1;else{for(;a>1;)o.sqrTo(s,v),o.sqrTo(v,s),a-=2;a>0?o.sqrTo(s,v):(d=s,s=v,v=d),o.mulTo(v,h[l],s)}for(;y>=0&&0==(t[y]&1<<n);)o.sqrTo(s,v),d=s,s=v,v=d,--n<0&&(n=this.DB-1,--y)}return o.revert(s)}function Wt(t){var e=this.s<0?this.negate():this.clone(),r=t.s<0?t.negate():t.clone();if(e.compareTo(r)<0){var i=e;e=r,r=i}var o=e.getLowestSetBit(),n=r.getLowestSetBit();if(n<0)return e;for(o<n&&(n=o),n>0&&(e.rShiftTo(n,e),r.rShiftTo(n,r));e.signum()>0;)(o=e.getLowestSetBit())>0&&e.rShiftTo(o,e),(o=r.getLowestSetBit())>0&&r.rShiftTo(o,r),e.compareTo(r)>=0?(e.subTo(r,e),e.rShiftTo(1,e)):(r.subTo(e,r),r.rShiftTo(1,r));return n>0&&r.lShiftTo(n,r),r}function Kt(t){if(t<=0)return 0;var e=this.DV%t,r=this.s<0?t-1:0;if(this.t>0)if(0==e)r=this[0]%t;else for(var i=this.t-1;i>=0;--i)r=(e*r+this[i])%t;return r}function Gt(t){var e=t.isEven();if(this.isEven()&&e||0==t.signum())return r.ZERO;for(var i=t.clone(),o=this.clone(),n=f(1),s=f(0),h=f(0),a=f(1);0!=i.signum();){for(;i.isEven();)i.rShiftTo(1,i),e?(n.isEven()&&s.isEven()||(n.addTo(this,n),s.subTo(t,s)),n.rShiftTo(1,n)):s.isEven()||s.subTo(t,s),s.rShiftTo(1,s);for(;o.isEven();)o.rShiftTo(1,o),e?(h.isEven()&&a.isEven()||(h.addTo(this,h),a.subTo(t,a)),h.rShiftTo(1,h)):a.isEven()||a.subTo(t,a),a.rShiftTo(1,a);i.compareTo(o)>=0?(i.subTo(o,i),e&&n.subTo(h,n),s.subTo(a,s)):(o.subTo(i,o),e&&h.subTo(n,h),a.subTo(s,a))}return 0!=o.compareTo(r.ONE)?r.ZERO:a.compareTo(t)>=0?a.subtract(t):a.signum()<0?(a.addTo(t,a),a.signum()<0?a.add(t):a):a}function Qt(t){var e,r=this.abs();if(1==r.t&&r[0]<=Te[Te.length-1]){for(e=0;e<Te.length;++e)if(r[0]==Te[e])return!0;return!1}if(r.isEven())return!1;for(e=1;e<Te.length;){for(var i=Te[e],o=e+1;o<Te.length&&i<ge;)i*=Te[o++];for(i=r.modInt(i);e<o;)if(i%Te[e++]==0)return!1}return r.millerRabin(t)}function Yt(t){var e=this.subtract(r.ONE),o=e.getLowestSetBit();if(o<=0)return!1;var n=e.shiftRight(o);t=t+1>>1,t>Te.length&&(t=Te.length);for(var s=i(),h=0;h<t;++h){s.fromInt(Te[Math.floor(Math.random()*Te.length)]);var a=s.modPow(n,this);if(0!=a.compareTo(r.ONE)&&0!=a.compareTo(e)){for(var u=1;u++<o&&0!=a.compareTo(e);)if(a=a.modPowInt(2,this),0==a.compareTo(r.ONE))return!1;if(0!=a.compareTo(e))return!1}}return!0}function te(t){be[_e++]^=255&t,be[_e++]^=t>>8&255,be[_e++]^=t>>16&255,be[_e++]^=t>>24&255,_e>=De&&(_e-=De)}function ee(){te((new Date).getTime())}function re(){if(null==we){for(ee(),we=ae(),we.init(be),_e=0;_e<be.length;++_e)be[_e]=0;_e=0}return we.next()}function ie(t){var e;for(e=0;e<t.length;++e)t[e]=re()}function oe(){}function ne(){this.i=0,this.j=0,this.S=new Array}function se(t){var e,r,i;for(e=0;e<256;++e)this.S[e]=e;for(r=0,e=0;e<256;++e)r=r+this.S[e]+t[e%t.length]&255,i=this.S[e],this.S[e]=this.S[r],this.S[r]=i;this.i=0,this.j=0}function he(){var t;return this.i=this.i+1&255,this.j=this.j+this.S[this.i]&255,t=this.S[this.i],this.S[this.i]=this.S[this.j],this.S[this.j]=t,this.S[t+this.S[this.i]&255]}function ae(){return new ne}var ue,pe=0xdeadbeefcafe,fe=15715070==(16777215&pe),ce="undefined"!=typeof navigator;ce&&fe&&"Microsoft Internet Explorer"==navigator.appName?(r.prototype.am=n,ue=30):ce&&fe&&"Netscape"!=navigator.appName?(r.prototype.am=o,ue=26):(r.prototype.am=s,ue=28),r.prototype.DB=ue,r.prototype.DM=(1<<ue)-1,r.prototype.DV=1<<ue;var le=52;r.prototype.FV=Math.pow(2,le),r.prototype.F1=le-ue,r.prototype.F2=2*ue-le;var de,ye,me="0123456789abcdefghijklmnopqrstuvwxyz",ve=new Array;for(de="0".charCodeAt(0),ye=0;ye<=9;++ye)ve[de++]=ye;for(de="a".charCodeAt(0),ye=10;ye<36;++ye)ve[de++]=ye;for(de="A".charCodeAt(0),ye=10;ye<36;++ye)ve[de++]=ye;k.prototype.convert=C,k.prototype.revert=R,k.prototype.reduce=O,k.prototype.mulTo=M,k.prototype.sqrTo=j,H.prototype.convert=I,H.prototype.revert=L,H.prototype.reduce=P,H.prototype.mulTo=N,H.prototype.sqrTo=V,r.prototype.copyTo=u,r.prototype.fromInt=p,r.prototype.fromString=c,r.prototype.clamp=l,r.prototype.dlShiftTo=w,r.prototype.drShiftTo=b,r.prototype.lShiftTo=_,r.prototype.rShiftTo=x,r.prototype.subTo=E,r.prototype.multiplyTo=S,r.prototype.squareTo=D,r.prototype.divRemTo=A,r.prototype.invDigit=q,r.prototype.isEven=U,r.prototype.exp=z,r.prototype.toString=d,r.prototype.negate=y,r.prototype.abs=m,r.prototype.compareTo=v,r.prototype.bitLength=g,r.prototype.mod=B,r.prototype.modPowInt=F,r.ZERO=f(0),r.ONE=f(1),qt.prototype.convert=Ht,qt.prototype.revert=Ht,qt.prototype.mulTo=It,qt.prototype.sqrTo=Lt,Ut.prototype.convert=zt,Ut.prototype.revert=Ft,Ut.prototype.reduce=Xt,Ut.prototype.mulTo=$t,Ut.prototype.sqrTo=Zt;var Te=[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509,521,523,541,547,557,563,569,571,577,587,593,599,601,607,613,617,619,631,641,643,647,653,659,661,673,677,683,691,701,709,719,727,733,739,743,751,757,761,769,773,787,797,809,811,821,823,827,829,839,853,857,859,863,877,881,883,887,907,911,919,929,937,941,947,953,967,971,977,983,991,997],ge=(1<<26)/Te[Te.length-1];r.prototype.chunkSize=W,r.prototype.toRadix=G,r.prototype.fromRadix=Q,r.prototype.fromNumber=Y,r.prototype.bitwiseTo=ot,r.prototype.changeBit=bt,r.prototype.addTo=St,r.prototype.dMultiply=Mt,r.prototype.dAddOffset=jt,r.prototype.multiplyLowerTo=Vt,r.prototype.multiplyUpperTo=Nt,r.prototype.modInt=Kt,r.prototype.millerRabin=Yt,r.prototype.clone=X,r.prototype.intValue=Z,r.prototype.byteValue=$,r.prototype.shortValue=J,r.prototype.signum=K,r.prototype.toByteArray=tt,r.prototype.equals=et,r.prototype.min=rt,r.prototype.max=it,r.prototype.and=st,r.prototype.or=at,r.prototype.xor=pt,r.prototype.andNot=ct,r.prototype.not=lt,r.prototype.shiftLeft=dt,r.prototype.shiftRight=yt,r.prototype.getLowestSetBit=vt,r.prototype.bitCount=gt,r.prototype.testBit=wt,r.prototype.setBit=_t,r.prototype.clearBit=xt,r.prototype.flipBit=Et,r.prototype.add=Dt,r.prototype.subtract=At,r.prototype.multiply=Bt,r.prototype.divide=Ct,r.prototype.remainder=Rt,r.prototype.divideAndRemainder=Ot,r.prototype.modPow=Jt,r.prototype.modInverse=Gt,r.prototype.pow=Pt,r.prototype.gcd=Wt,r.prototype.isProbablePrime=Qt,r.prototype.square=kt,r.prototype.Barrett=Ut;var we,be,_e;if(null==be){be=new Array,_e=0;var xe;if("undefined"!=typeof window&&window.crypto)if(window.crypto.getRandomValues){var Ee=new Uint8Array(32);for(window.crypto.getRandomValues(Ee),xe=0;xe<32;++xe)be[_e++]=Ee[xe]}else if("Netscape"==navigator.appName&&navigator.appVersion<"5"){var Se=window.crypto.random(32);for(xe=0;xe<Se.length;++xe)be[_e++]=255&Se.charCodeAt(xe)}for(;_e<De;)xe=Math.floor(65536*Math.random()),be[_e++]=xe>>>8,be[_e++]=255&xe;_e=0,ee()}oe.prototype.nextBytes=ie,ne.prototype.init=se,ne.prototype.next=he;var De=256;r.SecureRandom=oe,r.BigInteger=r,e=t.exports=r}).call(this)},function(t,e,r){function i(){}function o(t){if(!y(t))return t;var e=[];for(var r in t)n(e,r,t[r]);return e.join("&")}function n(t,e,r){if(null!=r)if(Array.isArray(r))r.forEach(function(r){n(t,e,r)});else if(y(r))for(var i in r)n(t,e+"["+i+"]",r[i]);else t.push(encodeURIComponent(e)+"="+encodeURIComponent(r));else null===r&&t.push(encodeURIComponent(e))}function s(t){for(var e,r,i={},o=t.split("&"),n=0,s=o.length;n<s;++n)e=o[n],r=e.indexOf("="),r==-1?i[decodeURIComponent(e)]="":i[decodeURIComponent(e.slice(0,r))]=decodeURIComponent(e.slice(r+1));return i}function h(t){var e,r,i,o,n=t.split(/\r?\n/),s={};n.pop();for(var h=0,a=n.length;h<a;++h)r=n[h],e=r.indexOf(":"),i=r.slice(0,e).toLowerCase(),o=w(r.slice(e+1)),s[i]=o;return s}function a(t){return/[\/+]json\b/.test(t)}function u(t){this.req=t,this.xhr=this.req.xhr,this.text="HEAD"!=this.req.method&&(""===this.xhr.responseType||"text"===this.xhr.responseType)||"undefined"==typeof this.xhr.responseType?this.xhr.responseText:null,
this.statusText=this.req.xhr.statusText;var e=this.xhr.status;1223===e&&(e=204),this._setStatusProperties(e),this.header=this.headers=h(this.xhr.getAllResponseHeaders()),this.header["content-type"]=this.xhr.getResponseHeader("content-type"),this._setHeaderProperties(this.header),null===this.text&&t._responseType?this.body=this.xhr.response:this.body="HEAD"!=this.req.method?this._parseBody(this.text?this.text:this.xhr.response):null}function p(t,e){var r=this;this._query=this._query||[],this.method=t,this.url=e,this.header={},this._header={},this.on("end",function(){var t=null,e=null;try{e=new u(r)}catch(e){return t=new Error("Parser is unable to parse the response"),t.parse=!0,t.original=e,r.xhr?(t.rawResponse="undefined"==typeof r.xhr.responseType?r.xhr.responseText:r.xhr.response,t.status=r.xhr.status?r.xhr.status:null,t.statusCode=t.status):(t.rawResponse=null,t.status=null),r.callback(t)}r.emit("response",e);var i;try{r._isResponseOK(e)||(i=new Error(e.statusText||"Unsuccessful HTTP response"),i.original=t,i.response=e,i.status=e.status)}catch(t){i=t}i?r.callback(i,e):r.callback(null,e)})}function f(t,e,r){var i=g("DELETE",t);return"function"==typeof e&&(r=e,e=null),e&&i.send(e),r&&i.end(r),i}var c;"undefined"!=typeof window?c=window:"undefined"!=typeof self?c=self:(console.warn("Using browser-only version of superagent in non-browser environment"),c=this);var l=r(4),d=r(10),y=r(1),m=r(9),v=r(11),T=r(12),g=e=t.exports=function(t,r){return"function"==typeof r?new e.Request("GET",t).end(r):1==arguments.length?new e.Request("GET",t):new e.Request(t,r)};e.Request=p,g.getXHR=function(){if(!(!c.XMLHttpRequest||c.location&&"file:"==c.location.protocol&&c.ActiveXObject))return new XMLHttpRequest;try{return new ActiveXObject("Microsoft.XMLHTTP")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP.6.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP.3.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP")}catch(t){}throw Error("Browser-only verison of superagent could not find XHR")};var w="".trim?function(t){return t.trim()}:function(t){return t.replace(/(^\s*|\s*$)/g,"")};g.serializeObject=o,g.parseString=s,g.types={html:"text/html",json:"application/json",xml:"application/xml",urlencoded:"application/x-www-form-urlencoded",form:"application/x-www-form-urlencoded","form-data":"application/x-www-form-urlencoded"},g.serialize={"application/x-www-form-urlencoded":o,"application/json":JSON.stringify},g.parse={"application/x-www-form-urlencoded":s,"application/json":JSON.parse},v(u.prototype),u.prototype._parseBody=function(t){var e=g.parse[this.type];return this.req._parser?this.req._parser(this,t):(!e&&a(this.type)&&(e=g.parse["application/json"]),e&&t&&(t.length||t instanceof Object)?e(t):null)},u.prototype.toError=function(){var t=this.req,e=t.method,r=t.url,i="cannot "+e+" "+r+" ("+this.status+")",o=new Error(i);return o.status=this.status,o.method=e,o.url=r,o},g.Response=u,l(p.prototype),d(p.prototype),p.prototype.type=function(t){return this.set("Content-Type",g.types[t]||t),this},p.prototype.accept=function(t){return this.set("Accept",g.types[t]||t),this},p.prototype.auth=function(t,e,r){switch("object"==typeof e&&null!==e&&(r=e),r||(r={type:"function"==typeof btoa?"basic":"auto"}),r.type){case"basic":this.set("Authorization","Basic "+btoa(t+":"+e));break;case"auto":this.username=t,this.password=e;break;case"bearer":this.set("Authorization","Bearer "+t)}return this},p.prototype.query=function(t){return"string"!=typeof t&&(t=o(t)),t&&this._query.push(t),this},p.prototype.attach=function(t,e,r){if(e){if(this._data)throw Error("superagent can't mix .send() and .attach()");this._getFormData().append(t,e,r||e.name)}return this},p.prototype._getFormData=function(){return this._formData||(this._formData=new c.FormData),this._formData},p.prototype.callback=function(t,e){if(this._maxRetries&&this._retries++<this._maxRetries&&T(t,e))return this._retry();var r=this._callback;this.clearTimeout(),t&&(this._maxRetries&&(t.retries=this._retries-1),this.emit("error",t)),r(t,e)},p.prototype.crossDomainError=function(){var t=new Error("Request has been terminated\nPossible causes: the network is offline, Origin is not allowed by Access-Control-Allow-Origin, the page is being unloaded, etc.");t.crossDomain=!0,t.status=this.status,t.method=this.method,t.url=this.url,this.callback(t)},p.prototype.buffer=p.prototype.ca=p.prototype.agent=function(){return console.warn("This is not supported in browser version of superagent"),this},p.prototype.pipe=p.prototype.write=function(){throw Error("Streaming is not supported in browser version of superagent")},p.prototype._appendQueryString=function(){var t=this._query.join("&");if(t&&(this.url+=(this.url.indexOf("?")>=0?"&":"?")+t),this._sort){var e=this.url.indexOf("?");if(e>=0){var r=this.url.substring(e+1).split("&");m(this._sort)?r.sort(this._sort):r.sort(),this.url=this.url.substring(0,e)+"?"+r.join("&")}}},p.prototype._isHost=function(t){return t&&"object"==typeof t&&!Array.isArray(t)&&"[object Object]"!==Object.prototype.toString.call(t)},p.prototype.end=function(t){return this._endCalled&&console.warn("Warning: .end() was called twice. This is not supported in superagent"),this._endCalled=!0,this._callback=t||i,this._appendQueryString(),this._end()},p.prototype._end=function(){var t=this,e=this.xhr=g.getXHR(),r=this._formData||this._data;this._setTimeouts(),e.onreadystatechange=function(){var r=e.readyState;if(r>=2&&t._responseTimeoutTimer&&clearTimeout(t._responseTimeoutTimer),4==r){var i;try{i=e.status}catch(t){i=0}if(!i){if(t.timedout||t._aborted)return;return t.crossDomainError()}t.emit("end")}};var i=function(e,r){r.total>0&&(r.percent=r.loaded/r.total*100),r.direction=e,t.emit("progress",r)};if(this.hasListeners("progress"))try{e.onprogress=i.bind(null,"download"),e.upload&&(e.upload.onprogress=i.bind(null,"upload"))}catch(t){}try{this.username&&this.password?e.open(this.method,this.url,!0,this.username,this.password):e.open(this.method,this.url,!0)}catch(t){return this.callback(t)}if(this._withCredentials&&(e.withCredentials=!0),!this._formData&&"GET"!=this.method&&"HEAD"!=this.method&&"string"!=typeof r&&!this._isHost(r)){var o=this._header["content-type"],n=this._serializer||g.serialize[o?o.split(";")[0]:""];!n&&a(o)&&(n=g.serialize["application/json"]),n&&(r=n(r))}for(var s in this.header)null!=this.header[s]&&this.header.hasOwnProperty(s)&&e.setRequestHeader(s,this.header[s]);return this._responseType&&(e.responseType=this._responseType),this.emit("request",this),e.send("undefined"!=typeof r?r:null),this},g.get=function(t,e,r){var i=g("GET",t);return"function"==typeof e&&(r=e,e=null),e&&i.query(e),r&&i.end(r),i},g.head=function(t,e,r){var i=g("HEAD",t);return"function"==typeof e&&(r=e,e=null),e&&i.send(e),r&&i.end(r),i},g.options=function(t,e,r){var i=g("OPTIONS",t);return"function"==typeof e&&(r=e,e=null),e&&i.send(e),r&&i.end(r),i},g.del=f,g.delete=f,g.patch=function(t,e,r){var i=g("PATCH",t);return"function"==typeof e&&(r=e,e=null),e&&i.send(e),r&&i.end(r),i},g.post=function(t,e,r){var i=g("POST",t);return"function"==typeof e&&(r=e,e=null),e&&i.send(e),r&&i.end(r),i},g.put=function(t,e,r){var i=g("PUT",t);return"function"==typeof e&&(r=e,e=null),e&&i.send(e),r&&i.end(r),i}},function(t,e,r){function i(t){var e=o(t)?Object.prototype.toString.call(t):"";return"[object Function]"===e}var o=r(1);t.exports=i},function(t,e,r){function i(t){if(t)return o(t)}function o(t){for(var e in i.prototype)t[e]=i.prototype[e];return t}var n=r(1);t.exports=i,i.prototype.clearTimeout=function(){return clearTimeout(this._timer),clearTimeout(this._responseTimeoutTimer),delete this._timer,delete this._responseTimeoutTimer,this},i.prototype.parse=function(t){return this._parser=t,this},i.prototype.responseType=function(t){return this._responseType=t,this},i.prototype.serialize=function(t){return this._serializer=t,this},i.prototype.timeout=function(t){if(!t||"object"!=typeof t)return this._timeout=t,this._responseTimeout=0,this;for(var e in t)switch(e){case"deadline":this._timeout=t.deadline;break;case"response":this._responseTimeout=t.response;break;default:console.warn("Unknown timeout option",e)}return this},i.prototype.retry=function(t){return 0!==arguments.length&&t!==!0||(t=1),t<=0&&(t=0),this._maxRetries=t,this._retries=0,this},i.prototype._retry=function(){return this.clearTimeout(),this.req&&(this.req=null,this.req=this.request()),this._aborted=!1,this.timedout=!1,this._end()},i.prototype.then=function(t,e){if(!this._fullfilledPromise){var r=this;this._endCalled&&console.warn("Warning: superagent request was sent twice, because both .end() and .then() were called. Never call .end() if you use promises"),this._fullfilledPromise=new Promise(function(t,e){r.end(function(r,i){r?e(r):t(i)})})}return this._fullfilledPromise.then(t,e)},i.prototype.catch=function(t){return this.then(void 0,t)},i.prototype.use=function(t){return t(this),this},i.prototype.ok=function(t){if("function"!=typeof t)throw Error("Callback required");return this._okCallback=t,this},i.prototype._isResponseOK=function(t){return!!t&&(this._okCallback?this._okCallback(t):t.status>=200&&t.status<300)},i.prototype.get=function(t){return this._header[t.toLowerCase()]},i.prototype.getHeader=i.prototype.get,i.prototype.set=function(t,e){if(n(t)){for(var r in t)this.set(r,t[r]);return this}return this._header[t.toLowerCase()]=e,this.header[t]=e,this},i.prototype.unset=function(t){return delete this._header[t.toLowerCase()],delete this.header[t],this},i.prototype.field=function(t,e){if(null===t||void 0===t)throw new Error(".field(name, val) name can not be empty");if(this._data&&console.error(".field() can't be used if .send() is used. Please use only .send() or only .field() & .attach()"),n(t)){for(var r in t)this.field(r,t[r]);return this}if(Array.isArray(e)){for(var i in e)this.field(t,e[i]);return this}if(null===e||void 0===e)throw new Error(".field(name, val) val can not be empty");return"boolean"==typeof e&&(e=""+e),this._getFormData().append(t,e),this},i.prototype.abort=function(){return this._aborted?this:(this._aborted=!0,this.xhr&&this.xhr.abort(),this.req&&this.req.abort(),this.clearTimeout(),this.emit("abort"),this)},i.prototype.withCredentials=function(t){return void 0==t&&(t=!0),this._withCredentials=t,this},i.prototype.redirects=function(t){return this._maxRedirects=t,this},i.prototype.toJSON=function(){return{method:this.method,url:this.url,data:this._data,headers:this._header}},i.prototype.send=function(t){var e=n(t),r=this._header["content-type"];if(this._formData&&console.error(".send() can't be used if .attach() or .field() is used. Please use only .send() or only .field() & .attach()"),e&&!this._data)Array.isArray(t)?this._data=[]:this._isHost(t)||(this._data={});else if(t&&this._data&&this._isHost(this._data))throw Error("Can't merge these send calls");if(e&&n(this._data))for(var i in t)this._data[i]=t[i];else"string"==typeof t?(r||this.type("form"),r=this._header["content-type"],"application/x-www-form-urlencoded"==r?this._data=this._data?this._data+"&"+t:t:this._data=(this._data||"")+t):this._data=t;return!e||this._isHost(t)?this:(r||this.type("json"),this)},i.prototype.sortQuery=function(t){return this._sort="undefined"==typeof t||t,this},i.prototype._timeoutError=function(t,e,r){if(!this._aborted){var i=new Error(t+e+"ms exceeded");i.timeout=e,i.code="ECONNABORTED",i.errno=r,this.timedout=!0,this.abort(),this.callback(i)}},i.prototype._setTimeouts=function(){var t=this;this._timeout&&!this._timer&&(this._timer=setTimeout(function(){t._timeoutError("Timeout of ",t._timeout,"ETIME")},this._timeout)),this._responseTimeout&&!this._responseTimeoutTimer&&(this._responseTimeoutTimer=setTimeout(function(){t._timeoutError("Response timeout of ",t._responseTimeout,"ETIMEDOUT")},this._responseTimeout))}},function(t,e,r){function i(t){if(t)return o(t)}function o(t){for(var e in i.prototype)t[e]=i.prototype[e];return t}var n=r(13);t.exports=i,i.prototype.get=function(t){return this.header[t.toLowerCase()]},i.prototype._setHeaderProperties=function(t){var e=t["content-type"]||"";this.type=n.type(e);var r=n.params(e);for(var i in r)this[i]=r[i];this.links={};try{t.link&&(this.links=n.parseLinks(t.link))}catch(t){}},i.prototype._setStatusProperties=function(t){var e=t/100|0;this.status=this.statusCode=t,this.statusType=e,this.info=1==e,this.ok=2==e,this.redirect=3==e,this.clientError=4==e,this.serverError=5==e,this.error=(4==e||5==e)&&this.toError(),this.accepted=202==t,this.noContent=204==t,this.badRequest=400==t,this.unauthorized=401==t,this.notAcceptable=406==t,this.forbidden=403==t,this.notFound=404==t}},function(t,e){var r=["ECONNRESET","ETIMEDOUT","EADDRINFO","ESOCKETTIMEDOUT"];t.exports=function(t,e){return!!(t&&t.code&&~r.indexOf(t.code))||(!!(e&&e.status&&e.status>=500)||(!!(t&&"timeout"in t&&"ECONNABORTED"==t.code)||!!(t&&"crossDomain"in t)))}},function(t,e){e.type=function(t){return t.split(/ *; */).shift()},e.params=function(t){return t.split(/ *; */).reduce(function(t,e){var r=e.split(/ *= */),i=r.shift(),o=r.shift();return i&&o&&(t[i]=o),t},{})},e.parseLinks=function(t){return t.split(/ *, */).reduce(function(t,e){var r=e.split(/ *; */),i=r[0].slice(1,-1),o=r[1].split(/ *= */)[1].slice(1,-1);return t[o]=i,t},{})},e.cleanHeader=function(t,e){return delete t["content-type"],delete t["content-length"],delete t["transfer-encoding"],delete t.host,e&&delete t.cookie,t}},function(t,e,r){var i,o;!function(n,s,h){"undefined"!=typeof t&&t.exports?t.exports=h():(i=h,o="function"==typeof i?i.call(e,r,e,t):i,!(void 0!==o&&(t.exports=o)))}("urljoin",this,function(){function t(t,e){return t=t.replace(/:\//g,"://"),t=t.replace(/([^:\s])\/+/g,"$1/"),t=t.replace(/\/(\?|&|#[^!])/g,"$1"),t=t.replace(/(\?.+)\?/g,"$1&")}return function(){var e=arguments,r={};"object"==typeof arguments[0]&&(e=arguments[0],r=arguments[1]||{});var i=[].slice.call(e,0).join("/");return t(i,r)}})},function(t,e){function r(){}r.prototype.get=function(){return null},r.prototype.has=function(){return!1},r.prototype.set=function(){},t.exports=r},function(t,e){function r(t){this.name="ConfigurationError",this.message=t||""}function i(t){this.name="TokenValidationError",this.message=t||""}r.prototype=Error.prototype,i.prototype=Error.prototype,t.exports={ConfigurationError:r,TokenValidationError:i}},function(t,e,r){function i(t){var e=s.decodeToHEX(t.n),r=s.decodeToHEX(t.e);return{modulus:e,exp:r}}function o(t,e){var r=n(t.iss,".well-known","jwks.json");return h.get(r).end(function(r,o){var n,s,h=null;for(r&&e(r),n=0;n<o.body.keys.length&&null===h;n++)s=o.body.keys[n],s.kid===t.kid&&(h=s);e(null,i(h))})}var n=r(14),s=r(2),h=r(8);t.exports={process:i,getJWKS:o}},function(t,e,r){function i(t,e){if(this.n=null,this.e=0,!(null!=t&&null!=e&&t.length>0&&e.length>0))throw new Error("Invalid key data");this.n=new n(t,16),this.e=parseInt(e,16)}function o(t){for(var e in h){var r=h[e],i=r.length;if(t.substring(0,i)===r)return{alg:e,hash:t.substring(i)}}return[]}var n=r(7).BigInteger,s=r(6),h={sha1:"3021300906052b0e03021a05000414",sha224:"302d300d06096086480165030402040500041c",sha256:"3031300d060960864801650304020105000420",sha384:"3041300d060960864801650304020205000430",sha512:"3051300d060960864801650304020305000440",md2:"3020300c06082a864886f70d020205000410",md5:"3020300c06082a864886f70d020505000410",ripemd160:"3021300906052b2403020105000414"},a={sha256:s};i.prototype.verify=function(t,e){e=e.replace(/[^0-9a-f]|[\s\n]]/gi,"");var r=new n(e,16);if(r.bitLength()>this.n.bitLength())throw new Error("Signature does not match with the key modulus.");var i=r.modPowInt(this.e,this.n),s=i.toString(16).replace(/^1f+00/,""),h=o(s);if(0===h.length)return!1;if(!a.hasOwnProperty(h.alg))throw new Error("Hashing algorithm is not supported.");var u=a[h.alg](t).toString();return h.hash===u},t.exports=i}])});
//# sourceMappingURL=idtoken-verifier.min.js.map